#! /bin/sh
# @(#)clean.sh	2.1 (ESO-IPG) 09/27/91 12:56:13
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           clean.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 scratch.
#                 Usage: install system [options]
#
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    30-Oct-1989:		Installation.
# .VERSION 1.2    05-Dec-1989:		Adding "echo" definition

echo=echo
if [ "`echo -n`" = "-n" ] ; then
        SV_NONL="\c"
else
        echo="echo -n"
fi

#
# First of all, goto the config directory MID_INSTALL
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

#
# START
#
#clear
task="unknown"
while :
do
echo ""
echo "	       MIDAS DELETE MENU:"
echo "	===================================="
echo "	1 - Delete only object files."
echo "	2 - Delete object and source files."
echo "	3 - Delete object, source files and libraries."
echo "	4 - Delete documentation."
echo "	5 - Delete executable files."
echo "	q - Quit."
echo ""
$echo "Select: " $SV_NONL

read task
task=`echo $task | tr A-Z a-z`

echo ""
case $task in
    1) 
	echo "1. This option will delete all files *.o"
	echo "   under $MID_HOME"
	$echo "   Total number of blocks to be deleted (wait): " $SV_NONL
	find $MID_HOME -name "*.o" -exec ls -s {} \; | \
	awk 'BEGIN { size=0 } { size=size+$1 } \
	     END {print size; if (size == 0) exit 1}'
	;;
    2) 
	echo "2. This option will delete all files *.o *.for *.c"
	echo "   under $MID_HOME"
	$echo "   Total number of blocks to be deleted (wait): " $SV_NONL
	find $MID_HOME \( \
		-name "*.o" -o \
		-name "*.for" -o  \
		-name "*.c" \) -exec ls -s {} \; | \
	awk 'BEGIN { size=0 } { size=size+$1 } \
	     END {print size; if (size == 0) exit 1}'
	;;
    3) 
	echo "3. This option will delete all files *.o *.for *.c *.a"
	echo "   under $MID_HOME"
	$echo "   Total number of blocks to be deleted (wait): " $SV_NONL
	find $MID_HOME \( \
		-name "*.o" -o \
		-name "*.for" -o  \
		-name "*.a" -o  \
		-name "*.c" \) -exec ls -s {} \; | \
	awk 'BEGIN { size=0 } { size=size+$1 } \
	     END {print size; if (size == 0) exit 1}'
	;;
    4) 
	echo "4. This option will delete all files "
	echo "	 under $MID_HOME/doc"
	$echo "   Total number of blocks to be deleted: " $SV_NONL
	du -s $MID_HOME/doc | awk '{print $1; if (size == 0) exit 1}'
	;;
    5)  /bin/sh $MID_INSTALL/delete
	continue
	;;
    q) 
	exit
	;;
    *)  echo "Selection unknown"
	continue
	;;
esac

if [ $? != 0 ]; then
    continue
fi

echo ""
$echo "Do you want to continue [yn]? (y): " $SV_NONL
read answ
if [ -z "$answ" ]; then
    answ=y
fi
if [ "$answ" != "y" -a "$answ" != "Y" ]
then
    continue
fi
#exit

echo "Start removing."
case $task in
     1)
	echo 'find $MID_HOME -name "*.o" -exec rm -f {} \;'
	find $MID_HOME -name "*.o" -exec rm -f {} \;
	;;
     2)
	echo 'find $MID_HOME \( \
		-name "*.o" -o \
		-name "*.for" -o  \
		-name "*.c" \) -exec rm -f {} \;'
	find $MID_HOME \( \
		-name "*.o" -o \
		-name "*.for" -o  \
		-name "*.c" \) -exec rm -f {} \;
	;;
     3)
	echo 'find $MID_HOME \( \
		-name "*.o" -o \
		-name "*.for" -o  \
		-name "*.c" -o  \
		-name "*.a" \) -exec rm -f {} \;'
	find $MID_HOME \( \
		-name "*.o" -o \
		-name "*.for" -o  \
		-name "*.c" -o  \
		-name "*.a" \) -exec rm -f {} \;
	;;
     4)
	echo 'rm -r $MID_HOME/doc'
	rm -r $MID_HOME/doc
	;;
esac

echo "Done."
done
